
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android系统显示原理 / 憋错料</title>

    <meta name="description" content="Android系统显示原理 应用层 Android显示过程的概括:Android应用程序把经过测量.布局.绘制后的surface缓存数据,通过SurfaceFlinger把数据渲染到显示屏幕上,通过Android的刷新机制来刷新数据.也就是说应用层负责绘制,系统层负责渲染,通过进程间通信把应用层需要绘制的数据传递到系统层服务,系统层服务通过刷新机制把数据更新到屏幕. 绘制原理中每个View绘制的三个步骤中Measure和Layout都是递归来获取View的大小和位置,层级越深,元素越多,耗时也就越长. 1.Measure">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android系统显示原理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h3>应用层</h3>
<p>Android显示过程的概括：Android应用程序把经过测量、布局、绘制后的surface缓存数据，通过SurfaceFlinger把数据渲染到显示屏幕上，通过Android的刷新机制来刷新数据。也就是说应用层负责绘制，系统层负责渲染，通过进程间通信把应用层需要绘制的数据传递到系统层服务，系统层服务通过刷新机制把数据更新到屏幕。</p>
<p>绘制原理中每个View绘制的三个步骤中Measure和Layout都是递归来获取View的大小和位置，层级越深，元素越多，耗时也就越长。</p>
<pre><code>1.Measure
用深度优先规则递归得到所有试图(View)的宽、高；获取当前View的宽度childWidthMeasureSpec和高度childHeightMeasureSpec之后，
可以调用它的成员函数Measure来设置它的大小。如果当前正在测量的子视图child是一个视图容器，那么它又会重复执行操作，
直到它的所有子孙视图的大小都测量完成为止

2.Layout
用深度优先原则递归得到所有View的位置；当一个子View在应用程序窗口左上角的位置确定之后，再结合它在前边测量过程中确定的宽度和高度，就可以完全确定它在应用程序窗口中的布局。

3.Draw
目前Android有两种绘制方式，软件绘制CPU与硬件加速GPU，GPU的显示和绘制效率远高于CPU，但也有缺点：耗电，兼容问题，内存大(使用openGL的接口至少需要8MB内存)
</code></pre>
<h3>系统层</h3>
<p>真正把需要显示的数据渲染到屏幕上，通过SufaceFlinger服务实现的</p>
<p>简单过程</p>
<p>1.响应客户端事件，创建Layer与客户端的Surface建立连接</p>
<p>2.接受客户端数据与属性，修改Layer属性，比如尺寸、颜色、透明度等</p>
<p>3.将创建的Layer内容刷新到屏幕上</p>
<p>4.维持Layer序列，并对Layer最终输出做出裁剪计算</p>
<p>在Android的显示系统，使用了Android的匿名共享内存：SharedClient，每一个应用和SurfaceFlinger之间都会创建一个SharedClient，每个SharedClient中最多创建31哥SharedBufferStack，每个Surface都对应一个SharedBufferStack，也就是一个window。同时每个SharedBufferStack又包含了两个或三个缓冲区，surfaceFlinger在驱动层把缓冲区中的数据渲染到屏幕。</p>
<h4>FPS</h4>
<p>这个表示每秒传递的帧数，老生常谈16ms发一次VSYNC信号，触发UI渲染，这就是60FPS，超了就会丢帧感到卡顿不流畅，可能是Layout太复杂了，也可能是UI上有太多的绘制单元，还可能是动画执行的次数太多</p>
<h3>卡顿的根本原因</h3>
<p>主要就是两个方面</p>
<pre><code>1.绘制任务太重，绘制一帧的内容耗时太长
2.主线程太忙，导致VSYNC信号来的时候还没准备好数据导致丢帧
</code></pre>
<p>主线程主要干的工作</p>
<pre><code>1.UI生命周期控制
2.系统事件处理
3.消息处理
4.界面布局
5.界面绘制
6.界面刷新
除了这些之外，其他活尽量避免让主线程去干</code></pre>

<p>原文地址：https://www.cnblogs.com/yinyulong/p/12702272.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 22:06:46 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e8%bf%9e%e6%8e%a5/" title="连接">连接</a>, <a href="https://www.biecuoliao.com/tag/%e9%97%ae%e9%a2%98/" title="问题">问题</a>, <a href="https://www.biecuoliao.com/tag/%e8%ae%be%e7%bd%ae/" title="设置">设置</a>, <a href="https://www.biecuoliao.com/tag/%e5%8e%9f%e7%90%86/" title="原理">原理</a>, <a href="https://www.biecuoliao.com/tag/%e8%bd%af%e4%bb%b6/" title="软件">软件</a>, <a href="https://www.biecuoliao.com/tag/%e5%93%8d%e5%ba%94/" title="响应">响应</a>, <a href="https://www.biecuoliao.com/tag/syn/" title="syn">syn</a>, <a href="https://www.biecuoliao.com/tag/raw/" title="raw">raw</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%9b%e7%a8%8b%e9%97%b4/" title="进程间">进程间</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android系统显示原理的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgyApL3.html" rel="bookmark">Android系统显示框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 Linux 驱动   FrameBuffer 在内核层,系统屏幕是使用一个称为帧缓冲区的硬件设备来描述的,而用户空间的应用程序可以通过设备文件/dev/fb0或者/dev/graphics /fb0来操作这个硬件设备.实际上,帧缓冲区本身并不是一个真正的硬件,它只不过是对显卡的一个抽象表示,不过,我们通过访帧缓冲区就可以间接地操作显 卡内存以及显卡中的其它寄存器 2 硬件抽象层(HAL)模块Gralloc 为了在屏幕中绘制一个指定的画面,我们需要: 1.  分配一个匹配屏幕大小的图形缓冲区			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/388pA23.html" rel="bookmark">Android 显示原理简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转:http://djt.qq.com/article/view/987 作者:yearzhu,2011年进入腾讯公司,从事过Web端及移动端的测试工作,喜爱新鲜事物及新技术,目前在SNG开放平台测试组负责的移动互联SDK的测试工作. 现在越来越多的应用开始重视流畅度方面的测试,了解Android应用程序是如何在屏幕上显示的则是基础中的基础,就让我们一起看看小小屏幕中大大的学问.这也是我下篇文章——&lt;Android应用流畅度测试分析&gt;的基础. 首先,用一句话来概括一下Android应用程序显示			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmA9ppM.html" rel="bookmark">（转载）Android显示原理简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android应用程序显示的过程:Android应用程序调用SurfaceFlinger服务把经过测量.布局和绘制后的Surface渲染到显示屏幕上. 名词解释 SurfaceFlinger:Android系统服务,负责管理Android系统的帧缓冲区,即显示屏幕. Surface:Android应用的每个窗口对应一个画布(Canvas),即Surface,可以理解为Android应用程序的一个窗口. Android应用程序的显示过程包含了两个部分(应用侧绘制.系统侧渲染).两个机制(进程间通讯			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vAKNZ0.html" rel="bookmark">【转】Android 显示原理简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:yearzhu,2011年进入腾讯公司,从事过Web端及移动端的测试工作,喜爱新鲜事物及新技术,目前在SNG开放平台测试组负责的移动互联SDK的测试工作. 原文链接 现在越来越多的应用开始重视流畅度方面的测试,了解Android应用程序是如何在屏幕上显示的则是基础中的基础,就让我们一起看看小小屏幕中大大的学问.这也是我下篇文章——&lt;Android应用流畅度测试分析&gt;的基础. 首先,用一句话来概括一下Android应用程序显示的过程:Android应用程序调用SurfaceFlinger服			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Jbpql4.html" rel="bookmark">［转］安卓显示原理介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://djt.qq.com/article/view/987 作者:yearzhu,2011年进入腾讯公司,从事过Web端及移动端的测试工作,喜爱新鲜事物及新技术,目前在SNG开放平台测试组负责的移动互联SDK的测试工作. 现在越来越多的应用开始重视流畅度方面的测试,了解Android应用程序是如何在屏幕上显示的则是基础中的基础,就让我们一起看看小小屏幕中大大的学问.这也是我下篇文章——&lt;Android应用流畅度测试分析&gt;的基础. 首先,用一句话来概括一下Android应用程序显			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49eppv4.html" rel="bookmark">Android系统Recovery工作原理之使用update&period;zip升级过程分析（六）---Recovery服务流程细节【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文转载自:http://blog.csdn.net/mu0206mu/article/details/7465439  Android系统Recovery工作原理之使用update.zip升级过程分析(六)---Recovery服务流程细节            Recovery服务毫无疑问是Recovery启动模式中最核心的部分.它完成Recovery模式所有的工作.Recovery程序对应的源码文件位于:/gingerbread0919/bootable/recovery/recovery			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mmwn7B3.html" rel="bookmark">Android系统  应用图标显示未读消息数&lpar;BadgeNumber&rpar; 桌面app图标的角标显示</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				参考: http://dev.xiaomi.com/doc/p=3904/index.html http://my.oschina.net/ososchina/blog/352286?p=1#comments https://github.com/leolin310148/ShortcutBadger http://www.voidcn.com/blog/kongbaidepao/article/p-62251.html http://www.eoeandroid.com/thread-5572			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aokzQ4.html" rel="bookmark">Android系统Recovery工作原理之使用update&period;zip升级过程---updater-script脚本语法简介以及执行流程&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目前update-script脚本格式是edify,其与amend有何区别,暂不讨论,我们只分析其中主要的语法,以及脚本的流程控制. 一.update-script脚本语法简介: 我们顺着所生成的脚本来看其中主要涉及的语法. 1.assert(condition):如果condition参数的计算结果为False,则停止脚本执行,否则继续执行脚本. 2.show_progress(frac,sec):frac表示进度完成的数值,sec表示整个过程的总秒数.主要用与显示UI上的进度条. 3.for			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWbqOm4.html" rel="bookmark">android系统平台显示驱动开发简要：LCD基本原理篇『一』</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				平台信息:内核:linux3.4.39系统:android4.4 平台:S5P4418(cortex a9) 作者:瘋耔(欢迎转载,请注明作者) 欢迎指正错误,共同学习.共同进步!! 关注博主新浪博客:http://weibo.com/cpjphone 从在校时玩单片机的点阵屏,到工作后android系统下的LCD,他们像一条流水线,顺应,简单的原理构成了复杂的结构: 我们来梳理一下: 玩51用的点阵 玩51用的lcd1602 玩51.32用的TFT彩屏 对于点阵的原理相比大多数朋友都非常熟悉,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MEvVX0.html" rel="bookmark" class="title">CSS 巧用 &colon;before和&colon;after</a>
					<div>
						前几天的晚上较全面的去看了下css的一些文档和资料,大部分的样式运用都没什么大问题了,只是有些许较陌生,但是也知道他们的存在和实现的是什么样式.今天主要想在这篇学习笔记中写的也不多,主要是针对:bef ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPwYB4.html" rel="bookmark" class="title">AFNetworking发送和接收字符串时报3840错误的解决办法</a>
					<div>
						AFNetworking框架默认请求类型和响应类型都是JSON格式的,在特殊情况下,我们使用字符串形式的时候,就会报3840错误,如何解决呢? 设置请求管理者: // 因为传递过去和接收回来的数据都不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eAxeJ0.html" rel="bookmark" class="title">java&mdash;&mdash;多线程&mdash;&mdash;单例模式的static方法和非static方法是否是线程安全的？</a>
					<div>
						单例模式的static方法和非static方法是否是线程安全的? 答案是:单例模式的static方法和非static方法是否是线程安全的,与单例模式无关.也就说,如果static方法或者非static ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35VER24.html" rel="bookmark" class="title">UVA - 10304Optimal Binary Search Tree&lpar;递推）</a>
					<div>
						题目:UVA - 10304Optimal Binary Search Tree(递推) 题目大意:给出一组数,e1 &lt; e2 &lt; ... &lt; en,现在要求将这些数组成一棵二叉搜索 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02bQXE0.html" rel="bookmark" class="title">Python 条件语句day05</a>
					<div>
						Python 条件语句 Python条件语句是通过一条或多条语句的执行结果(True或者False)来决定执行的代码块. Python 编程中 if 语句用于控制程序的执行,基本形式为: if 判断条 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02DrDB4.html" rel="bookmark" class="title">斯诟橙我残毁圃讼装残杉搅韭豢诔</a>
					<div>
						http://blog.tianya.cn/blogger/post_read.asp?BlogID=5304651&amp;PostID=75682806&amp;page=1 http://blo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEZYrK0.html" rel="bookmark" class="title">hdu 5009 Paint Pearls</a>
					<div>
						首先把具有相同颜色的点缩成一个点,即数据离散化. 然后使用dp[i]表示涂满前i个点的最小代价.对于第i+1个点,有两种情况: 1)自己单独涂,即dp[i+1] = dp[i] + 1 2)从第k个节 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M61J2v4.html" rel="bookmark" class="title">iis7&period;5错误 配置错误</a>
					<div>
						iis7.5详细错误   HTTP 错误 500.19 - Internal Server Error无法访问请求的页面,因为该页的相关配置数据无效. 详细错误信息模块 IIS Web Core 通知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWAnxb3.html" rel="bookmark" class="title">关于眼光</a>
					<div>
						百科说:眼光是指在某一时刻,对某领域趋势准确预测的能力.而眼光好,自然就是当初选择了预测有增长趋势的领域事物投入. 眼光其实就是活在未来,对未来的预测判断指导决策现在的行动.就是让自己跳出当前的自我自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgnaV3.html" rel="bookmark" class="title">服务发布</a>
					<div>
						服务发布 结合上文,我们的服务已经可以正常运行了,但它的访问方式只能通过服务器IP加上端口来访问,如何通过域名的方式来访问到我们服务,本来想使用Kubernetes的Ingress来做,折腾一天感觉比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgp1L3.html" rel="bookmark" class="title">Django-跨站请求</a>
					<div>
						//用户验证Tonken 在Html 中 设置一个Token {% csrf_token %} //在代码Views.py 中返回值添加 context_instance=RequestContext ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AZ1vKM.html" rel="bookmark" class="title">使用JavaScript实现弹出层效果</a>
					<div>
						声明 阅读本文需要有一定的HTML.CSS和JavaScript基础 设计 实现弹出层效果的思路非常简单:将待显示的内容先隐藏,在触发某种条件后(如点击按钮),将原本隐藏的内容显示出来. 实现 &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j1vQ7M.html" rel="bookmark" class="title">Maven的一些小配置（续）</a>
					<div>
						跑Tomcat tomcat7:run -Dmaven.tomcat.port=81 跑Jetty jetty:run -Djetty.port=82 VM arguments -server -Xm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ek7pa4.html" rel="bookmark" class="title">指针学习&lpar;1&rpar;</a>
					<div>
						---恢复内容开始--- 在指针中*是取内容,&amp;是取地址 通常有两种的表示: 通过指针向指向的地址内容赋值 *p=a; //将p指向的地址里赋a值 注意:若a和p定义的变量类型不一样时,需要用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDNlY93.html" rel="bookmark" class="title">centos mysql 实战 第十九节课</a>
					<div>
						f					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmqY7M.html" rel="bookmark" class="title">bzoj2705【SDOI2012】Longge的问题</a>
					<div>
						2705: [SDOI2012]Longge的问题 Time Limit: 3 Sec  Memory Limit: 128 MB Submit: 2105  Solved: 1300 [Submit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KPPZJ3.html" rel="bookmark" class="title">python 邮件通知程序</a>
					<div>
						#!/usr/bin/env python # -*- coding: utf-8 -*- import sys reload(sys) from email.MIMEText import MIME ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyneAE0.html" rel="bookmark" class="title">函数的返回值&mdash;&mdash;指针</a>
					<div>
						在C语言中,对于一个数组或者结构体的操作,其实类似于java中对引用类型的操作,但C语言中并不能通过函数直接返回整个的引用类型.但我们可以采用指针的方式,return变量的类型为指针,这样就可以访问到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jaBgDM.html" rel="bookmark" class="title">T-SQL开发&mdash;&mdash;ID处理篇</a>
					<div>
						原文:T-SQL开发--ID处理篇 数据库自增ID功能中Identity.Timestamp.Uniqueidentifier的区别: 问题现象: 一般序号的产生,对于一般程序员而言,都是使用T-SQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49OnnX0.html" rel="bookmark" class="title">duilib作为播放器的ui嵌入到mfc中使用</a>
					<div>
						0.前言 之前看到某位大牛的仿迅雷播放器的教程,他有三个系列的文章:duilib入门简明教程(20讲).duilib(进阶教程17讲).仿迅雷播放器教程(15讲) 但是可惜的是,前面的两个系列都挺好, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
